#! This is a simple skeleton template.  Replace everything in <angle brackets> with the following definitions:
#!
#! <TemplateName>        - the name of the template
#! <TemplateDescription> - required description of the template
#! <ExtensionName>       - name of the extension template
#! <ExtensionDesc>       - required description of the extension
#! <InstanceName>        - the name of the instance of the class
#! <DefaultInstance>     - The default instance name, can be the same as <InstanceName>
#! <ClassLabel>          - the label of the class in libsrc
#! <Classification>      - the "parameter" in ABCIncludeFile (must be upper case)

#TEMPLATE(<TemplateName>,'<TemplateDescription>'),FAMILY('ABC')
#EXTENSION(<ExtensionName>,'<ExtensionDesc'),APPLICATION #! or PROCEDURE if local
#!====================================================================
#BOXED('Default prompts'),AT(0,0),WHERE(%False),HIDE
  #INSERT(%OOPHiddenPrompts(ABC))
#ENDBOXED
#!====================================================================
#PREPARE                                                    #!Set class name in case developers never edit it
  #CALL(%ReadABCFiles(ABC))                                 #!Read ABC class headers if needed
  #CALL(%SetClassDefaults(ABC),'<InstanceName>','<DefaultInstance>','<ClassLabel>')       #!Set local name from libsrc class name
#ENDPREPARE                                                 #! end #PREPARE
#!====================================================================
#ATSTART                                                    #!Execute this code before other template statements
  #CALL(%ReadABCFiles(ABC))                                 #!Read ABC class headers if needed
  #CALL(%SetClassDefaults(ABC),'<InstanceName>','<DefaultInstance>','<ClassLabel>')       #!Set local name from libsrc class name
#ENDAT                                                      #! end #ATSTART
#!====================================================================
#AT(%BeforeGenerateApplication)                             #!For exporting the class
  #CALL(%AddCategory(ABC),'<Classification>')               #!The parameter in the !ABCIncludeFile comment in the INC file
  #!Used for DLLMode_ and LinkMode_ pragmas (see defines tab #!in project editor)
  #CALL(%SetCategoryLocation(ABC),'<Classification>','<ClassLabel>') 
#ENDAT                                                      #! end #AT(%BeforeGenerateApplication)
#!====================================================================
#TAB('Tab text here')                                       #!Global object dialog
  #BUTTON('<ClassLabel> Class')                             #!Display a button
    #WITH(%ClassItem,'<InstanceName>')                      #!Show the global instance name
      #INSERT(%GlobalClassPrompts(ABC))                     #!Add the global class prompt dialog.
    #ENDWITH                                                #! end #WITH(%ClassItem,'DC')
  #ENDBUTTON                                                #! end #BUTTON('&Message Class')
#ENDTAB                                                     #! end #TAB('Global Message &Instance')
#!====================================================================
#TAB('Message &Base Class')                                 #!Global class dialog
  #PROMPT('&Default class:',FROM(%pClassName)),%ClassName,DEFAULT('<ClassLabel>'),REQ
  #DISPLAY()
  #BOXED(' Usage ')
    #DISPLAY('If you have another class you wish to use ')
    #DISPLAY('instead, select it from the list or use the ')
    #DISPLAY('default shown.')
  #ENDBOXED
#ENDTAB                                                     #! end #TAB('Message Base Class')
#!====================================================================
#AT(%GatherObjects)                                         #!Ensure objects are known and loaded in memory
  #CALL(%ReadABCFiles(ABC))                                 #!Read ABC class headers if needed
  #CALL(%AddObjectList(ABC),'<InstanceName>')               #!Add the template object to object list 
  #ADD(%ObjectList,%ThisObjectName)                         #!Add the object to the list of all objects
  #SET(%ObjectListType,'<ClassLabel>')                      #!Set the base class name
#ENDAT                                                      #! end #AT(%GatherObjects)
#!====================================================================
#AT(%GlobalDataClasses)                                     #!At global class embed point
  #CALL(%SetClassItem(ABC), '<InstanceName>')               #!Set the current instance
  #INSERT(%GenerateClass(ABC), '<InstanceName>','Global instance and definition'),NOINDENT  #!and generate class instance into column 1, but preserve indent of template code
#ENDAT                                                      #! end #AT(%GloballDataClasses)
#!====================================================================
#AT(%DemoClassMethodCodeSection),PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())  #!Add parent call embed point
  #CALL(%GenerateParentCall(ABC))                           #!Generate the parent call
#ENDAT                                                      #! end #AT(%DemoClassMethodCodeSection)
#!====================================================================
#IF(%BaseClassToUse())                                      #!If there is a base class
  #CALL(%FixClassName(ABC),%BaseClassToUse())               #!Assign the base class, cleaning up any errors
  #FOR(%pClassMethod)                                       #!For every method in this class
    #FOR(%pClassMethodPrototype),WHERE(%MethodEmbedPointValid()) #!and the prototype is not private  
      #CALL(%SetupMethodCheck(ABC))                         #!ensure the proper instance, any overrides, etc are generated
      #EMBED(%<ClassLabel>MethodDataSection,'<ClassLabel> Method Data Section'),%pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(,%FixClassName(%FixBaseClassToUse('<ClassLabel>'))),TREE(%GetEmbedTreeDesc('<Classification>','DATA'))
      #?CODE                                                #<!Add CODE statement for method
      #EMBED(%<ClassLabel>MethodCodeSection,'<ClassLabel> Method Code Section'),%pClassMethod,%pClassMethodPrototype,PREPARE(,%FixClassName(%FixBaseClassToUse('<ClassLabel>'))),TREE(%GetEmbedTreeDesc('<Classification>','CODE'))
      #CALL(%CheckAddMethodPrototype(ABC),%ClassLines)      #!Generate the prototype and structure for each method
    #ENDFOR                                                 #! end #FOR(%pClassMethodPrototype),WHERE(%MethodEmbedPointValid())
  #ENDFOR                                                   #! end #FOR(%pClassMethod)
  #CALL(%GenerateNewLocalMethods(ABC),'<Classification>',%True)         #!Generate any new methods code from class dialog, if present
#ENDIF                                                      #! end #IF(%BaseClassToUse())
#!====================================================================
#AT(%GlobalData)
  #INSERT(%GenerateClass(ABC),'<InstanceName>'),NOINDENT
#ENDAT 
#!====================================================================
#AT(%ProgramProcedures), WHERE(%ProgramExtension<>'DLL' OR ~%GlobalExternal)
  #CALL(%GenerateVirtuals(ABC), '<InstanceName>', 'Global Objects|Message Template', '%GlobalEmbedVirtuals(<TemplateName>)', %TRUE)
#ENDAT
#!====================================================================
#!Groups follow here==================================================
#!====================================================================
#GROUP(%ParentCallValid),AUTO
#DECLARE(%RVal)
#CALL(%ParentCallValid(ABC)),%RVal
#RETURN(%RVal)
#!====================================================================
#GROUP(%GlobalEmbedVirtuals, %TreeText, %DataText, %CodeText)
#EMBED(%<TemplateName>DataSection,'<TemplateName> Method Data Section'), %ApplicationTemplateInstance,%pClassMethod,%pClassMethodPrototype,TREE(%TreeText & %DataText)
  #?CODE
  #EMBED(%<TemplateName>CodeSection,'<TemplateName> Method Code Section'), %ApplicationTemplateInstance,%pClassMethod,%pClassMethodPrototype,TREE(%TreeText & %CodeText)
